"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from emissary_client_sdk.types import BaseModel
from emissary_client_sdk.utils import (
    FieldMetadata,
    MultipartFormMetadata,
    PathParamMetadata,
    RequestMetadata,
)
import io
import pydantic
from typing import IO, Optional, Union
from typing_extensions import Annotated, NotRequired, TypedDict


class FileTypedDict(TypedDict):
    file_name: str
    content: Union[bytes, IO[bytes], io.BufferedReader]
    content_type: NotRequired[str]


class File(BaseModel):
    file_name: Annotated[
        str, pydantic.Field(alias="file"), FieldMetadata(multipart=True)
    ]

    content: Annotated[
        Union[bytes, IO[bytes], io.BufferedReader],
        pydantic.Field(alias=""),
        FieldMetadata(multipart=MultipartFormMetadata(content=True)),
    ]

    content_type: Annotated[
        Optional[str],
        pydantic.Field(alias="Content-Type"),
        FieldMetadata(multipart=True),
    ] = None


class CreateDatasetRequestBodyTypedDict(TypedDict):
    r"""Provide your project name if you want to specify it."""

    file: NotRequired[FileTypedDict]
    r"""The dataset file to upload"""
    name: NotRequired[str]
    r"""The name of the dataset"""


class CreateDatasetRequestBody(BaseModel):
    r"""Provide your project name if you want to specify it."""

    file: Annotated[
        Optional[File],
        pydantic.Field(alias=""),
        FieldMetadata(multipart=MultipartFormMetadata(file=True)),
    ] = None
    r"""The dataset file to upload"""

    name: Annotated[Optional[str], FieldMetadata(multipart=True)] = None
    r"""The name of the dataset"""


class CreateDatasetRequestTypedDict(TypedDict):
    project_id: str
    r"""The ID of the project to delete"""
    request_body: CreateDatasetRequestBodyTypedDict
    r"""Provide your project name if you want to specify it."""


class CreateDatasetRequest(BaseModel):
    project_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the project to delete"""

    request_body: Annotated[
        CreateDatasetRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="multipart/form-data")),
    ]
    r"""Provide your project name if you want to specify it."""
