"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from emissary_client_sdk.types import BaseModel
from emissary_client_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetClassificationFromDeploymentRequestBodyTypedDict(TypedDict):
    r"""Provide your input for classification"""

    source_sentence: str
    r"""The input for which to get classification"""


class GetClassificationFromDeploymentRequestBody(BaseModel):
    r"""Provide your input for classification"""

    source_sentence: str
    r"""The input for which to get classification"""


class GetClassificationFromDeploymentRequestTypedDict(TypedDict):
    project_id: str
    r"""The ID of the project to retrieve deployments for"""
    deployment_id: str
    r"""The ID of the deployment to get classification from"""
    request_body: GetClassificationFromDeploymentRequestBodyTypedDict
    r"""Provide your input for classification"""


class GetClassificationFromDeploymentRequest(BaseModel):
    project_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the project to retrieve deployments for"""

    deployment_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""The ID of the deployment to get classification from"""

    request_body: Annotated[
        GetClassificationFromDeploymentRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""Provide your input for classification"""


class GetClassificationFromDeploymentResponseBodyTypedDict(TypedDict):
    r"""Successful operation"""

    id: NotRequired[str]
    r"""The unique identifier for the classification"""
    response: NotRequired[str]
    r"""The predicted classification from the deployment"""


class GetClassificationFromDeploymentResponseBody(BaseModel):
    r"""Successful operation"""

    id: Optional[str] = None
    r"""The unique identifier for the classification"""

    response: Optional[str] = None
    r"""The predicted classification from the deployment"""
