"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .datasetsummary import DatasetSummary, DatasetSummaryTypedDict
from emissary_client_sdk.types import BaseModel
from enum import Enum
from typing import Dict, List, Optional, Union
from typing_extensions import NotRequired, TypedDict


class TrainingJobDetailStatus(str, Enum):
    r"""The current status of the training job"""

    PENDING = "Pending"
    RUNNING = "Running"
    SUCCESS = "Success"
    FAILED = "Failed"
    TIMED_OUT = "TimedOut"
    CANCELLED = "Cancelled"


class TrainingLossTypedDict(TypedDict):
    timestamp: NotRequired[float]
    loss: NotRequired[float]


class TrainingLoss(BaseModel):
    timestamp: Optional[float] = None

    loss: Optional[float] = None


HyperParametersTypedDict = Union[str, float, int]


HyperParameters = Union[str, float, int]


class TrainingJobDetailTypedDict(TypedDict):
    r"""Training Job Object"""

    id: NotRequired[str]
    r"""The unique identifier for the training job"""
    name: NotRequired[str]
    r"""The name of the training job"""
    description: NotRequired[str]
    r"""A description of the training job"""
    base_model: NotRequired[str]
    r"""The base model used for training"""
    status: NotRequired[TrainingJobDetailStatus]
    r"""The current status of the training job"""
    progress: NotRequired[int]
    r"""The current progress of the training job"""
    train_dataset: NotRequired[DatasetSummaryTypedDict]
    r"""Dataset Summary Object"""
    test_dataset: NotRequired[DatasetSummaryTypedDict]
    r"""Dataset Summary Object"""
    training_loss: NotRequired[List[TrainingLossTypedDict]]
    hyper_parameters: NotRequired[Dict[str, HyperParametersTypedDict]]
    created_by: NotRequired[str]
    r"""The user ID who created the training job"""
    created_at: NotRequired[int]
    r"""The timestamp when the TrainingJob was created"""
    updated_at: NotRequired[int]
    r"""The timestamp when the TrainingJob was last updated"""


class TrainingJobDetail(BaseModel):
    r"""Training Job Object"""

    id: Optional[str] = None
    r"""The unique identifier for the training job"""

    name: Optional[str] = None
    r"""The name of the training job"""

    description: Optional[str] = None
    r"""A description of the training job"""

    base_model: Optional[str] = None
    r"""The base model used for training"""

    status: Optional[TrainingJobDetailStatus] = None
    r"""The current status of the training job"""

    progress: Optional[int] = None
    r"""The current progress of the training job"""

    train_dataset: Optional[DatasetSummary] = None
    r"""Dataset Summary Object"""

    test_dataset: Optional[DatasetSummary] = None
    r"""Dataset Summary Object"""

    training_loss: Optional[List[TrainingLoss]] = None

    hyper_parameters: Optional[Dict[str, HyperParameters]] = None

    created_by: Optional[str] = None
    r"""The user ID who created the training job"""

    created_at: Optional[int] = None
    r"""The timestamp when the TrainingJob was created"""

    updated_at: Optional[int] = None
    r"""The timestamp when the TrainingJob was last updated"""
